<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>gateway documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">gateway documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content miscellaneous-variables">
                   <div class="content-data">














                   

<ol class="breadcrumb">
  <li>Miscellaneous</li>
  <li>Variables</li>
</ol>

<section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <ul class="index-list">
                        <li>
                            <a href="#activateBusinessSchema" title="src/routes/business/index.ts"><b>activateBusinessSchema</b>&nbsp;&nbsp;&nbsp;(src/.../index.ts)</a>
                        </li>
                        <li>
                            <a href="#assignmentCompatibilityHack" title="src/common/events/strict-event-emitter.ts"><b>assignmentCompatibilityHack</b>&nbsp;&nbsp;&nbsp;(src/.../strict-event-emitter.ts)</a>
                        </li>
                        <li>
                            <a href="#businessRequestQuerySchema" title="src/routes/business/index.ts"><b>businessRequestQuerySchema</b>&nbsp;&nbsp;&nbsp;(src/.../index.ts)</a>
                        </li>
                        <li>
                            <a href="#commandHandlers" title="src/services/users/users.module.ts"><b>commandHandlers</b>&nbsp;&nbsp;&nbsp;(src/.../users.module.ts)</a>
                        </li>
                        <li>
                            <a href="#createBusinessSchema" title="src/routes/business/index.ts"><b>createBusinessSchema</b>&nbsp;&nbsp;&nbsp;(src/.../index.ts)</a>
                        </li>
                        <li>
                            <a href="#eventHandlers" title="src/services/users/users.module.ts"><b>eventHandlers</b>&nbsp;&nbsp;&nbsp;(src/.../users.module.ts)</a>
                        </li>
                        <li>
                            <a href="#logger" title="src/main.ts"><b>logger</b>&nbsp;&nbsp;&nbsp;(src/.../main.ts)</a>
                        </li>
                        <li>
                            <a href="#logger" title="src/services/users/repositories/user-authentication.repository.ts"><b>logger</b>&nbsp;&nbsp;&nbsp;(src/.../user-authentication.repository.ts)</a>
                        </li>
                        <li>
                            <a href="#logger" title="src/services/users/repositories/user-firebase.repository.ts"><b>logger</b>&nbsp;&nbsp;&nbsp;(src/.../user-firebase.repository.ts)</a>
                        </li>
                        <li>
                            <a href="#logger" title="src/services/users/repositories/user.repository.ts"><b>logger</b>&nbsp;&nbsp;&nbsp;(src/.../user.repository.ts)</a>
                        </li>
                        <li>
                            <a href="#mergeObjects" title="src/common/utility/pipe-utility.ts"><b>mergeObjects</b>&nbsp;&nbsp;&nbsp;(src/.../pipe-utility.ts)</a>
                        </li>
                        <li>
                            <a href="#notificationCredentialsSchema" title="src/routes/user/user.controller.ts"><b>notificationCredentialsSchema</b>&nbsp;&nbsp;&nbsp;(src/.../user.controller.ts)</a>
                        </li>
                        <li>
                            <a href="#objectPropertiesToSnakeCase" title="src/common/utility/string-utility.ts"><b>objectPropertiesToSnakeCase</b>&nbsp;&nbsp;&nbsp;(src/.../string-utility.ts)</a>
                        </li>
                        <li>
                            <a href="#objectToValuePairs" title="src/common/utility/pipe-utility.ts"><b>objectToValuePairs</b>&nbsp;&nbsp;&nbsp;(src/.../pipe-utility.ts)</a>
                        </li>
                        <li>
                            <a href="#pipe" title="src/common/utility/pipe-utility.ts"><b>pipe</b>&nbsp;&nbsp;&nbsp;(src/.../pipe-utility.ts)</a>
                        </li>
                        <li>
                            <a href="#PlainBody" title="src/common/decorator/raw-body-decorator.ts"><b>PlainBody</b>&nbsp;&nbsp;&nbsp;(src/.../raw-body-decorator.ts)</a>
                        </li>
                        <li>
                            <a href="#queryHandlers" title="src/services/users/users.module.ts"><b>queryHandlers</b>&nbsp;&nbsp;&nbsp;(src/.../users.module.ts)</a>
                        </li>
                        <li>
                            <a href="#removeUndefinedFromObject" title="src/common/utility/pipe-utility.ts"><b>removeUndefinedFromObject</b>&nbsp;&nbsp;&nbsp;(src/.../pipe-utility.ts)</a>
                        </li>
                        <li>
                            <a href="#renameObject" title="src/common/utility/pipe-utility.ts"><b>renameObject</b>&nbsp;&nbsp;&nbsp;(src/.../pipe-utility.ts)</a>
                        </li>
                        <li>
                            <a href="#RoleAccess" title="src/services/auth/authorization/role-access.decorator.ts"><b>RoleAccess</b>&nbsp;&nbsp;&nbsp;(src/.../role-access.decorator.ts)</a>
                        </li>
                        <li>
                            <a href="#Roles" title="src/services/auth/authorization/roles.decorator.ts"><b>Roles</b>&nbsp;&nbsp;&nbsp;(src/.../roles.decorator.ts)</a>
                        </li>
                        <li>
                            <a href="#serviceAccount" title="src/database/firebase/database.ts"><b>serviceAccount</b>&nbsp;&nbsp;&nbsp;(src/.../database.ts)</a>
                        </li>
                        <li>
                            <a href="#toKebabCase" title="src/common/utility/string-utility.ts"><b>toKebabCase</b>&nbsp;&nbsp;&nbsp;(src/.../string-utility.ts)</a>
                        </li>
                        <li>
                            <a href="#toSnakeCase" title="src/common/utility/string-utility.ts"><b>toSnakeCase</b>&nbsp;&nbsp;&nbsp;(src/.../string-utility.ts)</a>
                        </li>
                        <li>
                            <a href="#validate" title="src/services/auth/social/facebook/validation.ts"><b>validate</b>&nbsp;&nbsp;&nbsp;(src/.../validation.ts)</a>
                        </li>
                        <li>
                            <a href="#valuePairsToObject" title="src/common/utility/pipe-utility.ts"><b>valuePairsToObject</b>&nbsp;&nbsp;&nbsp;(src/.../pipe-utility.ts)</a>
                        </li>
                    </ul>
                </td>
            </tr>
        </tbody>
    </table>
</section>

    <h3>src/routes/business/index.ts</h3>
    <section>
    <h3></h3>        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="activateBusinessSchema"></a>
                        <span class="name">
                            <b>
                            activateBusinessSchema</b>
                            <a href="#activateBusinessSchema"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>Joi.object({
    user_id: Joi.string()
        .min(5)
        .max(50)
        .alphanum()
        .required(),
    access_token: Joi.string()
        .min(5)
        .max(500)
        // .alphanum()
        .required(),
    social_provider: Joi.string()
        .min(5)
        .max(50)
        .alphanum()
        .required(),
    business_id: Joi.string()
        .min(5)
        .max(50)
        .alphanum()
        .required()
})</code>
                        </td>
                    </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="businessRequestQuerySchema"></a>
                        <span class="name">
                            <b>
                            businessRequestQuerySchema</b>
                            <a href="#businessRequestQuerySchema"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>Joi.object&lt;IBusinessRequestQuery&gt;({
    limit: Joi.number()
        .min(0)
        .max(100)
        .integer()
        .optional(),
    offset: Joi.number()
        .min(0)
        .max(100)
        .integer()
        .optional(),
})</code>
                        </td>
                    </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="createBusinessSchema"></a>
                        <span class="name">
                            <b>
                            createBusinessSchema</b>
                            <a href="#createBusinessSchema"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>Joi.object&lt;ICreateBusinessPayload&gt;({
    zone_id: Joi.string()
        .allow(&#x27;&#x27;)
        .optional(),
    businessName: Joi.string()
        .min(3)
        .max(30)
        .required(),
    sub_title: Joi.string()
        .allow(&#x27;&#x27;)
        .optional(),
    description: Joi.string()
        .min(3)
        .max(100)
        .required(),
    language: Joi.string()
        .valid(&#x27;se&#x27;, &#x27;en&#x27;, &#x27;dk&#x27;, &#x27;nl&#x27;)
        .max(50)
        .required(),
    latitude: Joi.number()
        .precision(20)
        .max(200)
        .min(-200)
        .required(),
    longitude: Joi.number()
        .precision(20)
        .max(200)
        .min(-200)
        .required(),
    emailAddress: Joi.string()
        .email()
        .required(),
    phoneNumber: Joi.string()
        .allow(&#x27;&#x27;, &#x27;-&#x27;, &#x27;+&#x27;)
        .alphanum()
        .optional(),
    // pin_type: Joi.string()
    //     .max(30)
    //     // .valid(...Object.values(PinTypes))
    //     .valid(...Object.keys(PinTypes))
    //     .required(),
    pin_type: Joi.string()
        .min(1)
        .max(30)
        .optional(),
    sub_pin_types: Joi.array()
        .min(0)
        .max(20)
        .optional(),
    socialMediaHandle: Joi.string()
        .allow(&#x27;&#x27;)
        .alphanum()
        .max(20)
        .optional(),
    socialMediaProvider: Joi.string()
        .max(20),
    municipality: Joi.object&lt;IMunicipalityPayload&gt;({
        municipality_fire_id: Joi.string()
            .min(10)
            .max(100)
            .required(),
        municipality_mongo_id: Joi.string()
            .min(24)
            .max(24)
            .required(),
        municipality_name: Joi.string()
            .min(2)
            .max(30)
            .required(),
        municipality_code: Joi.string()
            .length(4)
            .required()
    }),
    country: Joi.string()
        .valid(&#x27;sweden&#x27;, &#x27;norway&#x27;, &#x27;iceland&#x27;,
            &#x27;finland&#x27;, &#x27;germany&#x27;, &#x27;netherlands&#x27;,
            &#x27;england&#x27;, &#x27;denmark&#x27;)
        .min(3)
        .max(40)
        .required(),
})</code>
                        </td>
                    </tr>


            </tbody>
        </table>
</section>
    <h3>src/common/events/strict-event-emitter.ts</h3>
    <section>
    <h3></h3>        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="assignmentCompatibilityHack"></a>
                        <span class="name">
                            <b>
                            assignmentCompatibilityHack</b>
                            <a href="#assignmentCompatibilityHack"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>symbol</code>

                        </td>
                    </tr>


            </tbody>
        </table>
</section>
    <h3>src/services/users/users.module.ts</h3>
    <section>
    <h3></h3>        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="commandHandlers"></a>
                        <span class="name">
                            <b>
                            commandHandlers</b>
                            <a href="#commandHandlers"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>[]</code>

                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>[
  CreateUserCommandHandler,
  AddSocialAccountToUserCommandHandler,
]</code>
                        </td>
                    </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="eventHandlers"></a>
                        <span class="name">
                            <b>
                            eventHandlers</b>
                            <a href="#eventHandlers"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>[]</code>

                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>[
]</code>
                        </td>
                    </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="queryHandlers"></a>
                        <span class="name">
                            <b>
                            queryHandlers</b>
                            <a href="#queryHandlers"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>[]</code>

                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>[
  GetUserByIdQueryHandler,
  GetUsersByIdsQueryHandler,
]</code>
                        </td>
                    </tr>


            </tbody>
        </table>
</section>
    <h3>src/main.ts</h3>
    <section>
    <h3></h3>        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="logger"></a>
                        <span class="name">
                            <b>
                            logger</b>
                            <a href="#logger"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>new Logger(&#x27;Gateway&#x27;)</code>
                        </td>
                    </tr>


            </tbody>
        </table>
</section>
    <h3>src/services/users/repositories/user-authentication.repository.ts</h3>
    <section>
    <h3></h3>        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="logger"></a>
                        <span class="name">
                            <b>
                            logger</b>
                            <a href="#logger"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>new Logger(&#x27;UserAuthenticationRepository&#x27;)</code>
                        </td>
                    </tr>


            </tbody>
        </table>
</section>
    <h3>src/services/users/repositories/user-firebase.repository.ts</h3>
    <section>
    <h3></h3>        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="logger"></a>
                        <span class="name">
                            <b>
                            logger</b>
                            <a href="#logger"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>new Logger(&#x27;UserRepository&#x27;)</code>
                        </td>
                    </tr>


            </tbody>
        </table>
</section>
    <h3>src/services/users/repositories/user.repository.ts</h3>
    <section>
    <h3></h3>        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="logger"></a>
                        <span class="name">
                            <b>
                            logger</b>
                            <a href="#logger"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>new Logger(&#x27;UserMongoRepository&#x27;)</code>
                        </td>
                    </tr>


            </tbody>
        </table>
</section>
    <h3>src/common/utility/pipe-utility.ts</h3>
    <section>
    <h3></h3>        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="mergeObjects"></a>
                        <span class="name">
                            <b>
                            mergeObjects</b>
                            <a href="#mergeObjects"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>(...obj: object[]) &#x3D;&gt; {
    return obj.reduce((acc, curr) &#x3D;&gt; {
        return {
            ...acc,
            ...curr
        }
    }, {})
}</code>
                        </td>
                    </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="objectToValuePairs"></a>
                        <span class="name">
                            <b>
                            objectToValuePairs</b>
                            <a href="#objectToValuePairs"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>(
    obj: any,
): IValuePair[] &#x3D;&gt; {
    let entries &#x3D; Object.entries(obj)
    let pair: IValuePair[] &#x3D; entries.reduce((prev: any, curr: any) &#x3D;&gt; {
        return [
            ...prev,
            {
                prop: curr[0],
                value: curr[1],
            }
        ]
    }, [])
    return pair
}</code>
                        </td>
                    </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="pipe"></a>
                        <span class="name">
                            <b>
                            pipe</b>
                            <a href="#pipe"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>&lt;T extends any[], R&gt;(
    fn1: (...args: T) &#x3D;&gt; R,
    ...fns: Array&lt;(a: R) &#x3D;&gt; R&gt;
) &#x3D;&gt; {
    const piped &#x3D; fns.reduce(
        (prevFn, nextFn) &#x3D;&gt; (value: R) &#x3D;&gt; nextFn(prevFn(value)),
        value &#x3D;&gt; value
    )
    return (...args: T) &#x3D;&gt; piped(fn1(...args))
}</code>
                        </td>
                    </tr>

                <tr>
                    <td class="col-md-4">
                        <div class="io-description"><p><a href="https://dev.to/ascorbic/creating-a-typed-compose-function-in-typescript-3-351i">https://dev.to/ascorbic/creating-a-typed-compose-function-in-typescript-3-351i</a></p>
</div>
                    </td>
                </tr>

            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="removeUndefinedFromObject"></a>
                        <span class="name">
                            <b>
                            removeUndefinedFromObject</b>
                            <a href="#removeUndefinedFromObject"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>&lt;T&gt;(obj: T): Partial&lt;T&gt; &#x3D;&gt; {
    return Object.keys(obj).reduce((acc, key) &#x3D;&gt; {
        const _acc &#x3D; acc;
        if (obj[key] !&#x3D;&#x3D; undefined) {
            _acc[key] &#x3D; obj[key]
        }
        return _acc;
    }, {})
}</code>
                        </td>
                    </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="renameObject"></a>
                        <span class="name">
                            <b>
                            renameObject</b>
                            <a href="#renameObject"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>(
    arr: object,
    newName: string,
) &#x3D;&gt; {
    return Object.entries(arr).reduce((prev, curr) &#x3D;&gt; {
        return {
            ...prev,
            [&#x60;${newName}${curr[0]}&#x60;]: curr[1]
        }
    }, {})
}</code>
                        </td>
                    </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="valuePairsToObject"></a>
                        <span class="name">
                            <b>
                            valuePairsToObject</b>
                            <a href="#valuePairsToObject"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>(obj: {
    [key: string]: any,
    prop: string,
    value: any,
}[]) &#x3D;&gt; {
    return obj.reduce((acc, curr) &#x3D;&gt; {
        return {
            ...acc,
            [curr.prop]: curr.value
        }
    }, {})
}</code>
                        </td>
                    </tr>


            </tbody>
        </table>
</section>
    <h3>src/routes/user/user.controller.ts</h3>
    <section>
    <h3></h3>        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="notificationCredentialsSchema"></a>
                        <span class="name">
                            <b>
                            notificationCredentialsSchema</b>
                            <a href="#notificationCredentialsSchema"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>Joi.object&lt;INotificationCredentialsSchema&gt;({
    // _id: Joi.string()
    //     .min(24)
    //     .max(24)
    //     .required(),
    // notification_credentials: Joi.object&lt;INotificationCredential&gt;({
    device_id: Joi.string()
        .min(5)
        .max(100)
        .required(),
    notification_token: Joi.string()
        .min(5)
        .max(300)
        .required(),
    platform: Joi.string()
        .valid(...Object.keys(DevicePlatformsEnum))
        .required(),
    // }),
    // TODO: Implement other array types
})</code>
                        </td>
                    </tr>


            </tbody>
        </table>
</section>
    <h3>src/common/utility/string-utility.ts</h3>
    <section>
    <h3></h3>        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="objectPropertiesToSnakeCase"></a>
                        <span class="name">
                            <b>
                            objectPropertiesToSnakeCase</b>
                            <a href="#objectPropertiesToSnakeCase"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>(obj: IPOJO) &#x3D;&gt; {
    return Object.entries(obj).reduce((prev, curr) &#x3D;&gt; {
        return {
            ...prev,
            [toSnakeCase(curr[0])]: curr[1]
        }
    }, {})
}</code>
                        </td>
                    </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="toKebabCase"></a>
                        <span class="name">
                            <b>
                            toKebabCase</b>
                            <a href="#toKebabCase"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>(str: string) &#x3D;&gt;
    str &amp;&amp;
    str
        .match(/[A-Z]{2,}(?&#x3D;[A-Z][a-z]+[0-9]*|\b)|[A-Z]?[a-z]+[0-9]*|[A-Z]|[0-9]+/g)
        ?.map(x &#x3D;&gt; x.toLowerCase())
        .join(&#x27;-&#x27;)</code>
                        </td>
                    </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="toSnakeCase"></a>
                        <span class="name">
                            <b>
                            toSnakeCase</b>
                            <a href="#toSnakeCase"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>(str: string): string &#x3D;&gt;
    str &amp;&amp;
    str
        .match(/[A-Z]{2,}(?&#x3D;[A-Z][a-z]+[0-9]*|\b)|[A-Z]?[a-z]+[0-9]*|[A-Z]|[0-9]+/g)
        ?.map(x &#x3D;&gt; x.toLowerCase())
        .join(&#x27;_&#x27;) || &#x27;&#x27;</code>
                        </td>
                    </tr>


            </tbody>
        </table>
</section>
    <h3>src/common/decorator/raw-body-decorator.ts</h3>
    <section>
    <h3></h3>        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="PlainBody"></a>
                        <span class="name">
                            <b>
                            PlainBody</b>
                            <a href="#PlainBody"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>createParamDecorator(
    async (_, context: ExecutionContext) &#x3D;&gt; {
        const req &#x3D; context.switchToHttp().getRequest&lt;import(&quot;express&quot;).Request&gt;()
        if (!req.readable) {
            throw new BadRequestException(&quot;Invalid body&quot;)
        }

        const raw &#x3D; await rawBody.default(req)
        // const raw &#x3D; await rawBody(req)
        const body &#x3D; raw.toString(&quot;utf8&quot;).trim()
        return body
    })</code>
                        </td>
                    </tr>


            </tbody>
        </table>
</section>
    <h3>src/services/auth/authorization/role-access.decorator.ts</h3>
    <section>
    <h3></h3>        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="RoleAccess"></a>
                        <span class="name">
                            <b>
                            RoleAccess</b>
                            <a href="#RoleAccess"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>(...roles: RoleAccessTypes[]) &#x3D;&gt;
    SetMetadata(&#x27;role-access&#x27;, roles)</code>
                        </td>
                    </tr>


            </tbody>
        </table>
</section>
    <h3>src/services/auth/authorization/roles.decorator.ts</h3>
    <section>
    <h3></h3>        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="Roles"></a>
                        <span class="name">
                            <b>
                            Roles</b>
                            <a href="#Roles"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>(...roles: RoleTypes[]) &#x3D;&gt; SetMetadata(&#x27;roles&#x27;, roles)</code>
                        </td>
                    </tr>


            </tbody>
        </table>
</section>
    <h3>src/database/firebase/database.ts</h3>
    <section>
    <h3></h3>        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="serviceAccount"></a>
                        <span class="name">
                            <b>
                            serviceAccount</b>
                            <a href="#serviceAccount"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>require(&#x27;./../../../secrets/roamr-b1ce7-firebase-adminsdk-p0yxy-430d58f351.json&#x27;)</code>
                        </td>
                    </tr>


            </tbody>
        </table>
</section>
    <h3>src/services/auth/social/facebook/validation.ts</h3>
    <section>
    <h3></h3>        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="validate"></a>
                        <span class="name">
                            <b>
                            validate</b>
                            <a href="#validate"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>() &#x3D;&gt; {
    
}</code>
                        </td>
                    </tr>


            </tbody>
        </table>
</section>



                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'miscellaneous-variables';
            var COMPODOC_CURRENT_PAGE_URL = 'variables.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
